package com.hzs.common.core.enums;

import com.hzs.common.core.constant.EnumsPrefixConstants;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.ArrayList;
import java.util.List;

/**
 * 订单类型枚举类
 */
@AllArgsConstructor
@Getter
public enum EOrderType {

    /**
     * 注册订单
     */
    REGISTER_ORDER(1, "旧注册订单", 1, EnumsPrefixConstants.ORDER_TYPE + 1),

    /**
     * 升级订单
     */
    UPGRADE_ORDER(2, "旧升级订单", 1, EnumsPrefixConstants.ORDER_TYPE + 2),

    /**
     * 复购订单
     */
    REPURCHASE_ORDER(3, "旧复购订单", 1, EnumsPrefixConstants.ORDER_TYPE + 3),

    /**
     * 重消订单
     */
    CONSUME_ORDER(10, "旧重消订单", 1, EnumsPrefixConstants.ORDER_TYPE + 10),

    /**
     * 直播订单
     */
    MALL_ORDER(14, "直播订单", 1, EnumsPrefixConstants.ORDER_TYPE + 14),

    /**
     * 虚拟订单
     */
    FICTITIOUS_ORDER(20, "虚拟订单", 1, EnumsPrefixConstants.ORDER_TYPE + 20),

    /**
     * 新零售注册订单
     */
    RETAIL_REGISTER(41, "注册订单", 0, EnumsPrefixConstants.ORDER_TYPE + 41),
    /**
     * 新零售升级订单
     */
    RETAIL_UPGRADE(42, "升级订单", 0, EnumsPrefixConstants.ORDER_TYPE + 42),
    /**
     * 新零售复购订单
     */
    RETAIL_REPURCHASE(43, "复购订单", 0, EnumsPrefixConstants.ORDER_TYPE + 43),
    /**
     * 新零售重消订单
     */
    RETAIL_CONSUME(44, "重消订单", 0, EnumsPrefixConstants.ORDER_TYPE + 44),

    RETAIL_TICKET(45, "自助购票", 0, EnumsPrefixConstants.ORDER_TYPE + 45),

    RETAIL_PICK(46, "提货订单", 0, EnumsPrefixConstants.ORDER_TYPE + 46),

    ;

    /**
     * 实际值
     */
    private final int value;
    /**
     * 显示标签
     */
    private final String label;
    /**
     * 是否启用（0=是,1=否） -- 来源EYesNo
     */
    private final int enable;
    /**
     * 国际化翻译key值
     */
    private final String key;

    /**
     * 根据值，返回枚举
     *
     * @param value
     * @return
     */
    public static EOrderType getEnumByValue(int value) {
        for (EOrderType eOrderType : EOrderType.values()) {
            if (eOrderType.getValue() == value) {
                return eOrderType;
            }
        }
        return null;
    }

    /**
     * 根据值返回显示
     *
     * @param value
     * @return
     */
    public static String getEnumLabelByValue(int value) {
        for (EOrderType eOrderType : EOrderType.values()) {
            if (eOrderType.getValue() == value) {
                return eOrderType.getLabel();
            }
        }
        return "";
    }

    public static List<EOrderType> getOrderTypeSpecial() {
        List<EOrderType> resultList = new ArrayList<>();
        resultList.add(EOrderType.REGISTER_ORDER);
        resultList.add(EOrderType.UPGRADE_ORDER);
        resultList.add(EOrderType.REPURCHASE_ORDER);
        return resultList;
    }
    public static String getLabelByValue(Integer value) {
        if (null == value) {
            return "";
        }
        for (EOrderType enums : EOrderType.values()) {
            if (enums.getValue() == value) {
                return enums.getLabel();
            }
        }
        return "";
    }
}
